                MEMBER()
! (C) Copyright 2010 ProDomus, Inc., All Rights Reserved

!-- Include Files.
  INCLUDE('PDSQLFILTER.INC'),ONCE                          !-- Added by PD Class Generator Template
  INCLUDE('ABWINDOW.INC'),ONCE                             !-- Added by PD Class Generator Template
!-- Translation Files.  Be sure there are no translatable strings in the class library.
  INCLUDE('PDSQLFILTER.TRN','SOURCEDATA'),ONCE             !-- Added by PD Class Generator Template
!   A translate method should be provided if there are any strings in the TRN or Class Library Files.
!   If there are windows, consider using the SECTION directive in the translation file and INCLUDing this in the library CLW file.
!-- Other include Files.  Remember to add ,ONCE
!-- Data that is local to the class (CLW file).
FieldQT             QUEUE,TYPE
FieldNo               SIGNED
FieldFEQ              SIGNED
FieldAction           STRING(20)
                    END
QueryQT             QUEUE,TYPE
QueryName             STRING(250)
QueryID               ANY
                    END
QueryFieldQT        QUEUE,TYPE
QueryField            CSTRING(250)
                    END
LabelQT             QUEUE,TYPE
Prefix                STRING(250)
Label                 STRING(250)
                    END
ViewQT              QUEUE,TYPE
ViewFile              &FILE
ViewJoin              CSTRING(255)
                    END
ExcludeFilesQT      QUEUE,TYPE
ExcludeFile            STRING(250)
                    END
ExcludeFieldsQT     QUEUE,TYPE
ExcludeField          STRING(80)
                    END
eBrowseDragID       EQUATE('BROWSELIST')
eQueryFieldDragID   EQUATE('QUERYFIELD')                  
!-- Add MAP to include clarion standard library
  MAP
    MODULE('WIN Api')
      pd_OutPutDebug(*cstring),pascal,raw,name('OutputDebugStringA') !-- For use with SysInternals DebugView.
    END
  END
!-- Global Data Items From Application Data
!-- Methods
!------------------------------------------------------------------------------
PDSQLFilterCT.Construct PROCEDURE()
!------------------------------------------------------------------------------
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
    SELF.DebugOn=TRUE
    SELF.FieldQ &= NEW(FieldQT)
    CLEAR(self.FieldQ)
    SELF.QueryFieldQ &= NEW(QueryFieldQT)
    SELF.AddFields(FieldMapG)
    SELF.LabelQ &= NEW(LabelQT)
    SELF.QueryQ &= NEW(QueryQT)
    SELF.ViewQ &= NEW(ViewQT)
    SELF.ExcludeFilesQ &= NEW(ExcludeFilesQT)
    SELF.ExcludeFieldsQ &= NEW(ExcludeFieldsQT)
!------------------------------------------------------------------------------
PDSQLFilterCT.Destruct PROCEDURE()
!------------------------------------------------------------------------------
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
    IF NOT SELF.ViewQ &= NULL
      FREE(SELF.ViewQ)
      DISPOSE(SELF.ViewQ)
    END
    IF NOT SELF.FieldQ &= NULL
      FREE(SELF.FieldQ)
      DISPOSE(SELF.FieldQ)
    END
    IF NOT SELF.QueryFieldQ &= NULL
      FREE(SELF.QueryFieldQ)
      DISPOSE(SELF.QueryFieldQ)
    END
    IF NOT SELF.LabelQ&=NULL
      FREE(SELF.LabelQ)
      DISPOSE(SELF.LabelQ)
    END
    IF NOT SELF.QueryQ &= NULL
      FREE(SELF.QueryQ)
      DISPOSE(SELF.QueryQ)
    END
    IF NOT SELF.ExcludeFilesQ &= NULL
      FREE(SELF.ExcludeFilesQ)
      DISPOSE(SELF.ExcludeFilesQ)
    END
    IF NOT SELF.ExcludeFieldsQ &= NULL
      FREE(SELF.ExcludeFieldsQ)
      DISPOSE(SELF.ExcludeFieldsQ)
    END
!------------------------------------------------------------------------------
PDSQLFilterCT.AddFields PROCEDURE(*GROUP pFileMapG)
!------------------------------------------------------------------------------
!-- Adds control field identifiers to the queue of control fields.
I                         SIGNED(2)
Fields                    SIGNED
ThisField                 ANY
ThisNo                    SIGNED
ThisAction                STRING(20)

  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
    Fields= WHAT(pFileMapG,1)
    LOOP Fields TIMES
      ThisField &= WHAT(pFileMapG,I)
      ThisNo = ThisField
      ThisField &= WHAT(pFileMapG,I+1)
      ThisAction=ThisField
      IF ThisNo<>0
        SELF.AddField(ThisNo,,ThisAction)
      END
      I+=2
    END
!------------------------------------------------------------------------------
PDSQLFilterCT.AddQueryFields PROCEDURE()
!------------------------------------------------------------------------------
FileCount                         LONG
FieldCount                        LONG
FieldLabel                        STRING(255)
Counter                           LONG
FieldCounter                      LONG
TempString                        STRING(250)
ThisLabel                         STRING(250)
FileLabel                         STRING(250)
ThisPrefixLen                     LONG
ThisFile                          &FILE
PrefixFound                       BYTE
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
    FileCount = SELF.BC.View{PROP:Files,0}
    LOOP Counter=1 TO FileCount
      DO AddFiles 
    END
AddFiles            ROUTINE
  ThisFile &= SELF.BC.View{PROP:File,Counter}
  SELF.ExcludeFilesQ.ExcludeFile = UPPER(ThisFile{PROP:Name})
  !-- Check exclude file list.
  GET(SELF.ExcludeFilesQ,SELF.ExcludeFilesQ.ExcludeFile)
  IF NOT ERRORCODE()
    SELF.DebugOut('ExcludeFilefound: '&SELF.ExcludeFilesQ.ExcludeFile,'Filter.AddQueuryFields')
    EXIT
  ELSE
    SELF.DebugOut('ExcludeFileNOTfound: '&SELF.ExcludeFilesQ.ExcludeFile,'Filter.AddQueuryFields')
  END  
  DO AddFile
AddFile ROUTINE  
  FieldCount = ThisFile{PROP:Fields}
  ThisLabel = ThisFile{PROP:Name}
  IF ThisLabel=''
    ThisLabel = ThisFile{PROP:label,0}
  END
  SELF.ParseLabel(ThisLabel)
  IF Counter=1
    SELF.AddJoin(ThisFile,'')
  END  
  DO AddFileFields
AddFileFields           ROUTINE
  ThisFile{PROP:Alias}=Thislabel 
  PrefixFound=FALSE
  LOOP FieldCounter=1 TO FieldCount
    FieldLabel=ThisFile{PROP:Label,FieldCounter}
        !-- Check for excluded field
    SELF.ExcludeFieldsQ.ExcludeField = UPPER(FieldLabel)
    GET(SELF.ExcludeFieldsQ,SELF.ExcludeFieldsQ.ExcludeField)
    IF NOT ERRORCODE()
      EXIT
    END
        !-- Add to list of query fields and queue of prefix corss refences.
    CLEAR(TempString)
    TempString=ThisFile{PROP:Name,FieldCounter}
    IF TempString=''
      TempString = ThisFile{PROP:Label,FieldCounter}
    END
    IF TempString<>''
      IF ~PrefixFound
        PrefixFound=TRUE
        ThisPrefixLen=INSTRING(':',FieldLabel,1,1)
        SELF.DebugOut('PrefixLen: '&ThisPrefixLen,'Filter.AddQueryFields')
        IF ThisPrefixLen
          SELF.LabelQ.Prefix=FieldLabel[1: ThisPrefixLen]
          SELF.LabelQ.Label=ThisLabel
          SELF.DebugOut('Add Prefix: '&SELF.LabelQ.Prefix,'Filter.AddQueryFields')
          ADD(SELF.LabelQ,SELF.LabelQ.Prefix)
        END
      END
      SELF.ParseField(TempString,ThisLabel)
      SELF.AddQueryField(CLIP(TempString))
    END
  END
!------------------------------------------------------------------------------
PDSQLFilterCT.AcceptQuery PROCEDURE()
!------------------------------------------------------------------------------
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
   SELF.CheckQuery()
!------------------------------------------------------------------------------
PDSQLFilterCT.AddExcludeField PROCEDURE(STRING pField)
!------------------------------------------------------------------------------
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
    ASSERT(NOT SELF.ExcludeFieldsQ &= NULL,'Exclude field Queue is null')
    SELF.ExcludeFieldsQ.ExcludeField = UPPER(pField)
    ADD(SELF.ExcludeFieldsQ,SELF.ExcludeFieldsQ.ExcludeField)
!------------------------------------------------------------------------------
PDSQLFilterCT.AddExcludeFile PROCEDURE(STRING pFile)
!------------------------------------------------------------------------------
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
    ASSERT(NOT SELF.ExcludeFilesQ &= NULL,'Exclude file Queue is null')
    SELF.ExcludeFilesQ.ExcludeFile = UPPER(pFile)
    ADD(SELF.ExcludeFilesQ,SELF.ExcludeFilesQ.ExcludeFile)
    ASSERT(NOT ERRORCODE(),'Error adding exclude file '&ERROR())
!------------------------------------------------------------------------------
PDSQLFilterCT.AddField PROCEDURE(SIGNED pNo,SIGNED pFEQ=0,<STRING pAction>)
!------------------------------------------------------------------------------
eActionParm EQUATE(4)

  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
   SELF.FieldQ.FieldNo=pNo
    GET(SELF.FieldQ,SELF.FieldQ.FieldNo)
    IF ERRORCODE()
      SELF.FieldQ.FieldFEQ=pFEQ
      SELF.FieldQ.FieldAction=pAction
      ADD(SELF.FieldQ,SELF.FieldQ.FieldNo)
    ELSE
      IF NOT OMITTED(eActionParm)
        SELF.FieldQ.FieldAction=pAction
      END
      IF pFEQ
        SELf.FieldQ.FieldFEQ=pFEQ
      END
      PUT(SELF.FieldQ)
    END
!------------------------------------------------------------------------------
PDSQLFilterCT.AddJoin PROCEDURE(FILE pFile,STRING pJoin)
!------------------------------------------------------------------------------
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
    SELF.ViewQ.ViewFile &= pFile
    SELF.ViewQ.ViewJoin=pJoin
    ADD(SELF.ViewQ)
!------------------------------------------------------------------------------
PDSQLFilterCT.AddQueryField PROCEDURE(STRING pField)
!------------------------------------------------------------------------------
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
    CLEAR(SELF.QueryFieldQ)
    SELF.QueryFieldQ.QueryField=pField
    ADD(SELF.QueryFieldQ,SELF.QueryFieldQ.QueryField)
!------------------------------------------------------------------------------
PDSQLFilterCT.BuildAction PROCEDURE(STRING pAction)
!------------------------------------------------------------------------------
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
    SELF.Query=LEFT(CLIP(SELF.Query) & ' ' & pAction)
    DISPLAY
    SELF.CheckQuery() 
!------------------------------------------------------------------------------
PDSQLFilterCT.BuildField PROCEDURE()
!------------------------------------------------------------------------------
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
    IF SELF.GetFieldFEQ(eFld:QueryField) THEN RETURN.
    GET(SELF.QueryFieldQ,CHOICE(SELF.FieldQ.FieldFEQ))
    SELF.BuildAction(SELF.QueryFieldQ.QueryField)
    DISPLAY
    SELF.CheckQuery()
!------------------------------------------------------------------------------
PDSQLFilterCT.BuildText PROCEDURE()
!------------------------------------------------------------------------------
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
    IF SELF.GetFieldFEQ(eFld:Alpha) THEN RETURN.
    IF CONTENTS(SELF.FieldQ.FieldFEQ) = '' THEN RETURN.
    SELF.BuildAction(CLIP(CONTENTS(SELF.FieldQ.FieldFEQ)))
    CHANGE(SELF.FieldQ.fieldFEQ,'')
    DISPLAY
    SELF.CheckQuery()
!------------------------------------------------------------------------------
PDSQLFilterCT.CheckQuery PROCEDURE()
!------------------------------------------------------------------------------
RV BYTE

  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
    CLEAR(SELF.QueryError)
    DO TestQuery
    IF RV
      SELF.GoGreen
    ELSE
      SELF.GoRed
    END
    RETURN(RV)
TestQuery           ROUTINE
  SELF.BC.View{PROP:SQL} = 'SET NOEXEC ON SELECT * FROM ' & SELF.GetJoin() & |
    CHOOSE(SELF.Query<>'',' WHERE ' & SELF.DecodeQuery(SELF.Query),'') & ' SET NOEXEC OFF'
  IF ERRORCODE() = 0 
    RV = TRUE
  ELSE
    SELF.QueryError=FILEERROR()
  END
!------------------------------------------------------------------------------
PDSQLFilterCT.DecodeQuery PROCEDURE(STRING pCodedQuery)
!------------------------------------------------------------------------------
LocalReturnValue            STRING(10000)
StringPos                   LONG
EndBracket                  LONG
CodeLen                     LONG
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
    CodeLen = LEN('DATE<<')
 ! Fix Dates
    LOOP
      StringPos = INSTRING('DATE<<',pCodedQuery,1,1)
      EndBracket = INSTRING('>',pCodedQuery,1,StringPos)
      IF StringPos AND EndBracket
        pCodedQuery = pCodedQuery[1 : StringPos - 1] & |
          DEFORMAT(pCodedQuery[StringPos + CodeLen : EndBracket - 1],@D01) & |
          pCodedQuery[EndBracket + 1 : LEN(CLIP(pCodedQuery))]
      ELSE
        BREAK
      END
    END

 ! Fix Times
    CodeLen = LEN('TIME<<')
    LOOP
      StringPos = INSTRING('TIME<<',pCodedQuery,1,1)
      EndBracket = INSTRING('>',pCodedQuery,1,StringPos)
      IF StringPos AND EndBracket
        pCodedQuery = pCodedQuery[1 : StringPos - 1] & |
          DEFORMAT(pCodedQuery[StringPos + CodeLen : EndBracket - 1],@D04) & |
          pCodedQuery[EndBracket + 1 : LEN(CLIP(pCodedQuery))]
      ELSE
        BREAK
      END
    END
    LocalReturnValue = pCodedQuery
    RETURN(CLIP(pCodedQuery))
!------------------------------------------------------------------------------
PDSQLFilterCT.ExecQuery PROCEDURE()
!------------------------------------------------------------------------------
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
    IF ~SELF.CheckQuery()
      MESSAGE(SELF.TranslateString(eExecQueryMsga)&':<13,10,13,10>'&|
        CLIP(SELF.QueryError)&'<13,10><13,10>  '&SELF.TranslateString(eExecQueryMsgB),|
        SELF.TranslateString(eExecQueryMsgTitle),|
        ICON:Exclamation)
      CLEAR(SELF.QueryError)
    ELSE
      !SELF.BC.View{PROP:SQLFilter} = CLIP(SELF.DecodeQuery(SELF.Query))
      SELF.SetSqlFilter()
      SELF.BC.ResetFromBuffer
      SELF.BC.PostNewSelection
    END
!------------------------------------------------------------------------------
PDSQLFilterCT.GetFieldFEQ PROCEDURE(SIGNED pFld)
!------------------------------------------------------------------------------
RV                          BYTE
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
    SELF.FieldQ.FieldNo=pFld
    GET(SELF.FieldQ,SELF.FieldQ.FieldNo)
  !-- return true if a valid field control value is found
    RETURN CHOOSE(SELF.FieldQ.FieldFEQ=0 OR ERRORCODE(),TRUE,FALSE)
!------------------------------------------------------------------------------
PDSQLFilterCT.GetJoin PROCEDURE()
!------------------------------------------------------------------------------
RV                        STRING(5000)
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
    LOOP I#=1 TO RECORDS(SELF.ViewQ)
      GET(SELF.ViewQ,I#)
      RV = LEFT(CLIP(RV)&CHOOSE(SELF.ViewQ.ViewJoin<>'',' JOIN','')&' '&NAME(SELF.ViewQ.ViewFile)&' '&CLIP(SELF.ViewQ.ViewJoin))
    END
    SELF.DebugOut('Join: '&CLIP(RV),'Filter.GetJoin')
    RETURN CLIP(RV)
!------------------------------------------------------------------------------
PDSQLFilterCT.GetQueryActions PROCEDURE()
!------------------------------------------------------------------------------
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
  SELF.FieldQ.FieldFEQ{PROP:From} = '|=|<<>|>|<<|>=|<<=|BETWEEN|IN|NOT|AND|OR|LIKE|UPPER|LOWER|EXISTS|CONTAINS|MIN|MAX|AVG|SUM|COUNT|ALL|,|.|(|)'
!------------------------------------------------------------------------------
PDSQLFilterCT.GetQueryFileInfo PROCEDURE()
!------------------------------------------------------------------------------
TheFile                           &FILE
AKey                              &KEY
ThisGroup                         &GROUP
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
    IF SELF.QueryG.FM &= NULL THEN RETURN.
    DO r_GetKeysandFields
r_GetKeysAndFields  ROUTINE
  DATA
Keys    SIGNED
CategoryKey &KEY
  CODE
    TheFile &= SELF.QueryG.FM.File
    Keys=TheFile{PROP:Keys}
    ASSERT(NOT Keys < 2,'The Saved Query file needs at least two keys, one a primary id key, the other a category key.')
    LOOP I# = 1 TO Keys
      AKey &= TheFile{PROP:Key, I#}
      CASE AKey{PROP:Components}
      OF 1
        IF SELF.QueryFileIDKey &= NULL
          ASSERT(AKey{PROP:Primary}=1,'Single component key is not primary.')
          ASSERT(AKey{PROP:Dup}<>1,'Primary key must not allowd duplicates.')
          SELF.QueryfileIDKey &= TheFile{PROP:Key, I#}
        END
        IF SELF.QueryFileID &= NULL
          SELF.QueryFileID &= SELF.QueryG.FM.GetField(AKey,1)
        END
      OF 2
        IF SELF.QueryFileCategoryKey &= NULL
          ASSERT(AKey{PROP:Primary}='','Single component key is not primary.')
          ASSERT(AKey{PROP:Dup}<>1,'Named query key must not allowd duplicates.')
          SELF.QueryFileCategoryKey &= TheFile{PROP:Key, I#}
        END
        IF SELF.QueryFileCategory &= NULL
          SELF.QueryfileCategory &=SELF.QueryG.FM.GetField(AKey,1)
        END
        IF SELF.QueryFileName &= NULL
          SELF.QueryFileName &= SELF.QueryG.FM.GetField(AKey,2) 
        END
      ELSE
      !-- If there are keys that do not meet this spec, they you'll have to do some hand coding in the app embed.
      END
    END
    IF SELF.QueryFileQuery &= NULL
      ThisGroup &= TheFile{PROP:Record}
      SELF.QueryFileQuery &= WHAT(ThisGroup,eQueryPosition)
    END
    !-- If you get an error on one of these, you need to hand code missing field 
    !   references. Use the GetQueryFileInfo method before the parent call embed.
    !   Assign the following:
    !     SELF.QueryFileIDKey
    !     SELF.QueryFileID
    !     QueryFileCategoryKey
    !     QueryFileCategory
    !     QueryFileFileName
    !   Values can be set in the SetQueryFile method for loading.
    !   When Saving, values can be primed in the QueryFilePrimeUpdate method.
    ASSERT(NOT SELF.QueryFileName &= NULL,'Query field was not found. See notes above')
    ASSERT(NOT SELF.queryFileID &= NULL,'Primay field not found. See notes above')
    ASSERT(NOT SELF.QueryG.Category &= NULL,'Category not found. See notes above')
    ASSERT(NOT SELF.QueryFileQuery &= NULL,'The query field in the query file not found. See notes above')
!------------------------------------------------------------------------------
PDSQLFilterCT.GoGreen PROCEDURE()
!------------------------------------------------------------------------------
SavNo LONG
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
    Savno=SELF.FieldQ.FieldNo
    IF ~SELF.GetFieldFEQ(eFld:ExecQuery)
      SELF.FieldQ.FieldFEQ{PROP:FontColor}=COLOR:Green
    END
    IF ~SELF.GEtFieldFEQ(eFld:SaveQuery)
      IF SELF.FieldQ.FieldFEQ{PROP:Disable}=TRUE
        SELF.FieldQ.FieldFEQ{PROP:Disable}=FALSE
      END
    END
    SELF.GetFieldFEQ(SavNo)
!------------------------------------------------------------------------------
PDSQLFilterCT.GoRed PROCEDURE()
!------------------------------------------------------------------------------
SavNo LONG
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
    Savno=SELF.FieldQ.FieldNo
    IF ~SELF.GetFieldFEQ(eFld:ExecQuery)
      SELF.FieldQ.FieldFEQ{PROP:FontColor}=COLOR:Red
    END
    IF ~SELF.GEtFieldFEQ(eFld:SaveQuery)
      IF SELF.FieldQ.FieldFEQ{PROP:Disable}=FALSE
        SELF.FieldQ.FieldFEQ{PROP:Disable}=TRUE
      END
    END
    SELF.GetFieldFEQ(SavNo)
!------------------------------------------------------------------------------
PDSQLFilterCT.Init PROCEDURE(BrowseClass pBC,*STRING pQuery,*QUEUE pListQueue,SavedQueryGT pQueryG)
!------------------------------------------------------------------------------
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
    SELF.BC &= pBC
    SELF.ListQueue &= pListQueue
    SELF.Query &= pQuery
    SELF.QueryG = pQueryG
    SELF.AddQueryFields
    SELF.GetQueryActions
    SELF.GetQueryFileInfo
    SELF.LoadQueryQ()
!------------------------------------------------------------------------------
PDSQLFilterCT.LoadQuery PROCEDURE()
!------------------------------------------------------------------------------
  INCLUDE('PDSQLFILTER.TRN','LOADQUERY')
RV                        STRING(10000)
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
    RV=SELF.Query
    OPEN(LoadQueryW)
    GET(SELF.QueryQ,1)
    SELECT(?List,1)
    SELF.Translate(LoadQueryW)
    SELF.DebugOut('QueryQ Records: '&RECORDS(SELF.QueryQ),'Filter.LoadQuery')
    ACCEPT                                                                        
      CASE EVENT()
      OF EVENT:Accepted
        CASE FIELD()
        OF ?DeleteBtn
          GET(SELF.QueryQ,CHOICE(?List))
          IF NOT ERRORCODE()
            SELF.QueryFileID=SELF.QueryQ.QueryID
            IF ~SELF.QueryG.FM.TryFetch(SELF.QueryFileIDKey)
              SELF.QueryQ.QueryID=SELF.QueryFileID
              IF ~SELF.QueryG.FM.DeleteRecord()
                GET(SELF.QueryQ,SELF.QueryQ.QueryID)
                IF NOT ERRORCODE()
                  DELETE(SELF.QueryQ)
                END
              END
            END
          END
        OF ?SelectBtn
          GET(SELF.QueryQ,CHOICE(?List))
          IF NOT ERRORCODE()
            SELF.QueryFileID=SELF.QueryQ.QueryID
            IF ~SELF.QueryG.FM.TryFetch(SELF.QueryFileIDKey)
              RV= SELF.QueryFileQuery
              SELF.LastQueryID=SELF.QueryFileID
              BREAK
            END
          END
        END
      END
    END
    RETURN CLIP(RV)
!------------------------------------------------------------------------------
PDSQLFilterCT.LoadQueryAction PROCEDURE()
!------------------------------------------------------------------------------


  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
    SELF.Query=SELF.LoadQuery()
    IF ~CLIP(SELF.Query) THEN RETURN.
    DISPLAY
    IF SELF.CheckQuery()
      SELF.ExecQuery
    END
!------------------------------------------------------------------------------
PDSQLFilterCT.LoadQueryQ PROCEDURE()
!------------------------------------------------------------------------------
RV                                  BYTE
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
    IF SELF.QueryG.FM &= NULL
      RV=1
    ELSIF SELF.QueryG.FM.Open()
      RV=1
    ELSE
      SELF.QueryG.FM.UseFile()
      SELF.QueryG.FM.ClearKey(SELF.QueryFileCategoryKey)
      SELF.SetQueryFile()
      LOOP UNTIL SELF.QueryG.FM.Next()
        SELF.Debugout('Category '&SELF.QueryFileCategory,'Filter.loadQueryQ')
        IF SELF.QueryFileCategory<>SELF.QueryG.Category
          BREAK
        END
        CASE SELF.ValidateQueryRecord()
        OF 1 !Record Filtered
          CYCLE
        OF 2 !Out of Range
          BREAK
        END
        ASSERT(NOT SELF.QueryFileName&=NULL,'Query File name is NULL')
        ASSERT(NOT SELF.QueryQ &= NULL,'QueryQ is null')
        CLEAR(SELF.QueryQ)
        SELF.QueryQ.QueryName=SELF.QueryFileName
        SELF.QueryQ.QueryID=SELF.QueryFileID
        ADD(SELF.QueryQ,SELF.QueryQ.QueryName)
      END
      SELF.QueryG.FM.Close
    END
    RETURN RV
!------------------------------------------------------------------------------
PDSQLFilterCT.ParseField PROCEDURE(*STRING pField,STRING pLabel)
!------------------------------------------------------------------------------
i                           LONG
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
    i=INSTRING(':',pField,1,1)
    pField=CLIP(pLabel)&'.['&pField[i+1 : LEN(CLIP(pField))]&']'
!------------------------------------------------------------------------------
PDSQLFilterCT.ParseLabel PROCEDURE(*STRING pLabel)
!------------------------------------------------------------------------------
i                           LONG
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
    I = INSTRING('DBO.',UPPER(pLabel),1,1)
    IF I
      pLabel=pLabel[I+4 : LEN(CLIP(pLabel))]
    END
    I = INSTRING('.',pLabel,1,1)
    IF I
      pLabel=pLabel[1 : I-1]
    END
    LOOP I=LEN(CLIP(pLabel)) to 1 by -1
      CASE pLabel[I]
      OF '\'
        I+=1
        BREAK
      END
    END
    IF I=0 THEN I=1.
    pLabel=pLabel[I : LEN(CLIP(pLabel))]
!------------------------------------------------------------------------------
PDSQLFilterCT.QueryFilePrimeInsert PROCEDURE()
!------------------------------------------------------------------------------
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
!------------------------------------------------------------------------------
PDSQLFilterCT.QueryFilePrimeUpdate PROCEDURE()
!------------------------------------------------------------------------------
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
!------------------------------------------------------------------------------
PDSQLFilterCT.Reset PROCEDURE()
!------------------------------------------------------------------------------
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
    SELF.Query=''
    SELF.SetSQLFilter()
    IF ~SELF.GetFieldFEQ(eFld:Alpha)
      CHANGE(SELF.FieldQ.FieldFEQ,'')
    END
    SELF.LastQueryID &= NULL
    DISPLAY()
    IF SELF.CheckQuery()
      SELF.BC.ResetFromBuffer
      SELF.BC.PostNewSelection
    END
!------------------------------------------------------------------------------
PDSQLFilterCT.SaveQuery PROCEDURE()
!------------------------------------------------------------------------------
Overwrite                 BYTE
ThisName                  STRING(250)
SavName                   STRING(250)
                          INCLUDE('PDSQLFILTER.TRN','SAVEQUERY')
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
    OPEN(SaveQueryW)
    SELF.Translate(SaveQueryW)
    IF NOT SELF.LastQueryID &= NULL
      SELF.DebugOut('Last Query ID: '&SELF.LastQueryID,'Filter.SaveQuery')
      SELF.QueryFileID=SELF.lastQueryID
      IF ~SELF.QueryG.FM.TryFetch(SELF.QueryFileIDKey)
        SELF.DebugOut('Last Query ID Found','Filter.SaveQuery')
        ?LastQueryName{PROP:Text}=SELF.TranslateString(_Query_LastName)&': '&SELF.QueryFileName
        SavName=SELF.QueryFileName
        ThisName=SELf.QueryFileName
        Overwrite=TRUE
        UNHIDE(?Overwrite)
        UNHIDE(?LastQueryName)
        DISPLAY
      ELSE
        SELF.DebugOut('Last Query ID NOT Found','Filter.SaveQuery')
        SELF.LastQueryID &= NULL
      END
    END
    ACCEPT
      CASE ACCEPTED()
      OF ?OKButton
        IF Overwrite
          SELF.QueryFileName=ThisName
          SELF.QueryFileQuery=SELF.Query
          SELF.QueryFilePrimeUpdate()
          IF NOT SELF.QueryG.FM.Update()
            SELF.QueryQ.QueryName=SavName
            GET(SELf.QueryQ,SELF.QueryQ.QueryName)
            IF NOT ERRORCODE()
              SELF.QueryQ.QueryName=ThisName
              PUT(SELF.QueryQ)
              SORT(SELF.QueryQ,SELF.QueryQ.QueryName)
            ELSE
              SELF.DebugOut('Error Getting Prior Queue '&CLIP(SELF.QueryQ.QueryName)&' '&ERROR(),'FILTER.SaveQuery')
            END
          ELSE
            CYCLE
          END
        ELSE
          SELF.QueryFileName=ThisName
          SELF.QueryFileQuery=SELF.Query
          SELF.QueryFileCategory=SELf.QueryG.Category
          SELF.QueryFilePrimeInsert()
          IF NOT SELF.QueryG.FM.Insert()
            SELF.QueryQ.QueryName = ThisName
            SELF.QueryQ.QueryID = SELF.QueryFileID
            ADD(SELF.QueryQ,SELF.QueryQ.QueryName)
          ELSE
            CYCLE
          END
        END
        SELF.LastQueryID &= NULL
        POST(EVENT:CloseWindow)
      END
    END
!------------------------------------------------------------------------------
PDSQLFilterCT.SetAlerts PROCEDURE()
!------------------------------------------------------------------------------
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
    !-- Create the Drag region above the QueryField Drop List.
    IF ~SELF.GetFieldFEQ(eFld:QueryField)    
      SELF.QueryFieldRegion=CREATE(0,CREATE:region,SELF.FieldQ.FieldFEQ{PROP:Parent})
      SELF.QueryFieldRegion{PROP:Width}=SELF.FieldQ.FieldFEQ{PROP:Width}
      SELF.QueryFieldRegion{PROP:XPos}=SELF.FieldQ.FieldFEQ{PROP:Xpos}
      SELF.QueryFieldRegion{PROP:YPos}=SELF.FieldQ.FieldFEQ{PROP:Ypos}-12
      SELF.QueryFieldRegion{PROP:Height}=12
      SELF.QueryFieldRegion{PROP:TRN}=TRUE
      SELF.QueryFieldRegion{PROP:DragID}=eQueryFieldDragID
      UNHIDE(SELF.QueryFieldRegion)
    END
    !-- Set Other Drag and Drop ID's
    SELF.BC.ILC.GetControl(){PROP:DragId}=eBrowseDragID
    IF ~SELF.GetFieldFEQ(eFld:QueryField)
      SELf.FieldQ.FieldFEQ{PROP:From} = SELF.QueryFieldQ
    END
    IF ~SELF.GetFieldFEQ(eFld:QueryAction)
      SELF.GetQueryActions
    END
    IF ~SELF.GetFieldFEQ(eFld:Alpha)
      SELf.FieldQ.FieldFEQ{PROP:DropID}=eBrowseDragID
    END
    IF ~SELF.GetFieldFEQ(eFld:QueryBuilder)
      SELf.FieldQ.FieldFEQ{PROP:DropID}=eQueryFieldDragID
    END
!------------------------------------------------------------------------------
PDSQLFilterCT.SetQueryFile PROCEDURE()
!------------------------------------------------------------------------------
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
    ASSERT(NOT SELF.QueryG.Category &= NULL OR NOT SELF.QueryG.Category='','Query category must be specified')
    SELF.QueryFileCategory=SELF.QueryG.Category
    SET(SELF.QueryFileCategoryKey,SELF.QueryFileCategoryKey)
!------------------------------------------------------------------------------
PDSQLFilterCT.SetSQLFilter PROCEDURE()
!------------------------------------------------------------------------------
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
    IF SELF.Query<>''
      SELF.BC.SetFilter('(SQL(' & SELF.DecodeQuery(SELF.Query) & '))','PDSQLFILTER')
    ELSE
      SELF.BC.SetFilter('','PDSQLFILTER')
    END
!------------------------------------------------------------------------------
PDSQLFilterCT.TakeAccepted PROCEDURE()
!------------------------------------------------------------------------------
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
    IF SELF.FieldQ.FieldAction='NONE' OR SELF.FieldQ.FieldAction=''
      DO TakeFieldNo
    ELSE
      SELF.BuildAction(SELF.FieldQ.FieldAction)      
    END  
TakeFieldNo ROUTINE      
   CASE SELF.FieldQ.FieldNo
   OF eFld:QueryBuilder
     SELF.CheckQuery()
   OF eFld:ClearAll
     SELF.Reset
     SELF.CheckQuery()
   OF eFld:ExecQuery
     SELF.ExecQuery
   OF eFld:LoadQuery
     SELF.LoadQueryaction
     DISPLAY()
   OF eFld:SaveQuery
     IF CLIP(SELF.Query)
       SELF.SaveQuery
     END
   OF eFld:QueryField
      ! Do Nothing
   OF eFld:QueryAction
      ! Do Nothing
   OF eFld:Alpha
      ! do nothing.
   OF eFld:TextAdd
     SELF.BuildText
   OF eFld:EnterAllButton
     SELF.BuildField
     IF ~SELF.GetFieldFEQ(efld:QueryAction)
       IF CONTENTS(SELF.FieldQ.FieldFEQ)<>''
         SELF.BuildAction( CONTENTS(SELF.FieldQ.FieldFEQ) )
       END
     END
     SELF.BuildText
?  ELSE
?    ASSERT(0,'There is an unassigned field number.')
   END
!------------------------------------------------------------------------------
PDSQLFilterCT.TakeDropEvent PROCEDURE()
!------------------------------------------------------------------------------
RowChoice                     LONG
ColumnChoice                  LONG
FieldChoice                   STRING(250)
PrefixLen                     LONG
ValPic                        STRING(20)
TempString                    STRING(250)
lAlpha                        ANY
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
    SELF.DebugOut('DragID: '&DRAGID(),'Filter.TakeDropEvent')
    UPDATE()
    CASE DRAGID()
    OF eBrowseDragID
      DO GetBrowseItem
    OF eQueryFieldDragID
      DO GetQueryFieldItem
    END
GetQueryFieldItem   ROUTINE
  IF ~SELF.GetFieldFEQ(eFld:QueryField)
    SELF.DebugOut('Query: '&CLIP(SELF.Query)&' PLUS: '&CONTENTS(SELF.FieldQ.FieldFEQ),'Filter.GetQueryFieldItem') 
    SELF.BuildAction(CONTENTS(SELF.FieldQ.FieldFEQ))
    DISPLAY(SELF.FieldQ.FieldFEQ)
   END
  
GetBrowseItem       ROUTINE
    RowChoice = SELF.BC.ILC.GetControl(){PROPLIST:MouseDownRow}
    ColumnChoice = SELF.BC.ILC.GetControl(){PROPLIST:MouseDownField}
    GET(SELF.ListQueue,RowChoice)
    IF ERRORCODE()
      RETURN
    END
    lAlpha = WHAT(SELF.ListQueue,ColumnChoice)
    ValPic = SELF.BC.ILC.GetControl(){PROPLIST:Picture,ColumnChoice}
    CASE UPPER(ValPic[2])
    OF 'S'
      lAlpha = '''' & CLIP(LAlpha) & ''''
    OF 'D'
      lAlpha = 'DATE<<' & FORMAT(lAlpha,@D01) & '>'
    OF 'T'
      lAlpha = 'TIME<<' & FORMAT(LAlpha,@T04) & '>'
    END
    IF ~SELF.GetFieldFeq(eFld:Alpha)
      CHANGE(SELF.FieldQ.FieldFEQ,lAlpha)
    END
    FieldChoice = WHO(SELF.ListQueue,ColumnChoice)
    SELF.DebugOut('FieldChoice: '&CLIP(FieldChoice),'Filter.TakeDropEvent')
    PrefixLen = INSTRING(':',FieldChoice,1,1) !LEN('f')
    IF PreFixLen
      SELF.LabelQ.Prefix=FieldChoice[1 : PrefixLen]
      GET(SELF.LabelQ,SELF.LabelQ.Prefix)
      IF NOT ERRORCODE()
        SELF.ParseField(FieldChoice,SELF.LabelQ.Label)
      ELSE
        SELF.DebugOut('Error getting label: '&ERROR(),'Filter.TakeDropEvent')
        EXIT
      END
    END
    SELF.DebugOut('Field: '&CLIP(FieldChoice),'Filter.TakeDropEvent')
    IF ~SELF.GetFieldFeq(eFld:QueryField)
      CHANGE(SELF.FieldQ.FieldFEQ,FieldChoice) | !UPPER(FieldChoice[PrefixLen + 1 : LEN(CLIP(FieldChoice))]) & ']')
    ELSE 
      SELF.DebugOut('Error getting FieldFEQ','Filter.TakeDropEvent')
    END
    IF ~SELF.GetFieldFEQ(eFld:QueryAction)
      CHANGE(SELF.FieldQ.FieldFEQ, '=')
    END
    DISPLAY
!------------------------------------------------------------------------------
PDSQLFilterCT.TakeEvent PROCEDURE()
!------------------------------------------------------------------------------
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
    IF FIELD()
      SELF.FieldQ.FieldFEQ=FIELD()
      GET(SELF.FieldQ,SELF.FieldQ.FieldFEQ)
      IF NOT ERRORCODE()
        CASE EVENT()
        OF EVENT:Accepted
          SELF.TakeAccepted
        OF EVENT:NewSelection
          SELF.TakeNewSelection
        OF EVENT:Drop
          SELF.DebugOut('Event Drop','TakeEvent')
          IF SELF.FieldQ.FieldNo=eFld:Alpha
            SELF.TakeDropEvent
          ELSIF SELF.Fieldq.FieldNo=eFld:QueryBuilder
            SELF.TakeDropEvent
          END
        END
      END
    END
!------------------------------------------------------------------------------
PDSQLFilterCT.TakeNewSelection PROCEDURE()
!------------------------------------------------------------------------------
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
!------------------------------------------------------------------------------
PDSQLFilterCT.ValidateQueryRecord  PROCEDURE()
!------------------------------------------------------------------------------
RV                                  BYTE
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
   RETURN RV
!------------------------------------------------------------------------------
PDSQLFilterCT.Translate PROCEDURE(WINDOW pWin)             !-- Generated by template. For translation of windows.
!------------------------------------------------------------------------------
  CODE
!------------------------------------------------------------------------------
PDSQLFilterCT.TranslateString PROCEDURE(STRING pSTR)       !-- Generated by template. For translation of windows.
!------------------------------------------------------------------------------
  CODE
  RETURN CLIP(pStr)
!------------------------------------------------------------------------------
PDSQLFilterCT.DebugOut PROCEDURE(STRING pMsg,STRING pProc) !-- For use with SysInternals DebugView.
!------------------------------------------------------------------------------
lMessage CSTRING(255)
  CODE
    IF NOT SELF.DebugOn THEN RETURN.
    lMessage='`'&CLIP(pProc)&'-'&pMsg
    pd_OutPutDebug(lMessage)
!-- Interface method code.  Each method declared in the interface must be coded.
!------------------------------------------------------------------------------
PDSQLFilterCT.WindowComponent.Kill PROCEDURE()
!------------------------------------------------------------------------------
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
!------------------------------------------------------------------------------
PDSQLFilterCT.WindowComponent.Reset PROCEDURE(BYTE Force)
!------------------------------------------------------------------------------
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
!------------------------------------------------------------------------------
PDSQLFilterCT.WindowComponent.ResetRequired PROCEDURE()
!------------------------------------------------------------------------------
RV BYTE             
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
  RETURN RV
!------------------------------------------------------------------------------
PDSQLFilterCT.WindowComponent.SetAlerts PROCEDURE()
!------------------------------------------------------------------------------
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
    SELF.SetAlerts()
!------------------------------------------------------------------------------
PDSQLFilterCT.WindowComponent.TakeEvent PROCEDURE()
!------------------------------------------------------------------------------
RV BYTE             
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
      SELF.TakeEvent()                                                     
    RETURN RV
!------------------------------------------------------------------------------
PDSQLFilterCT.WindowComponent.Update PROCEDURE()
!------------------------------------------------------------------------------
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
!------------------------------------------------------------------------------
PDSQLFilterCT.WindowComponent.UpdateWindow PROCEDURE()
!------------------------------------------------------------------------------
  CODE
!-- Note that the template entry is in column 1.  Indenting is up to you.
