USE [HUFF]
GO
/****** Object:  Table [dbo].[QD_Offline]    Script Date: 01/21/2011 15:08:34 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
CREATE TABLE [dbo].[QD_Offline](
[Site] [char](4) NOT NULL,
[Inedible] [decimal](15, 4) NULL,
[InspDate] [int] NULL,
[InspOrder] [char](20) NOT NULL,
[inspstatus] [char](1) NULL,
[PalletNum] [char](20) NULL,
[BegWeight] [decimal](15, 4) NULL,
[EndWt] [decimal](15, 4) NULL,
[begintime] [int] NULL,
[Time] [int] NULL,
[sysdate] [int] NULL,
[systime] [int] NULL,
[UserID] [char](20) NULL,
[picture] [char](150) NULL,
[PONumber] [char](20) NULL,
[VendorID] [int] NULL,
[VName] [char](30) NULL,
[VLot] [varchar](20) NULL,
[WasClosed] [tinyint] NULL,
[ProductCode] [varchar](30) NULL,
 CONSTRAINT [PK_QD_Offline] PRIMARY KEY CLUSTERED 
(
[Site] ASC,
[InspOrder] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
SET ANSI_PADDING OFF
GO
/****** Object:  Table [dbo].[QD_HoldDetail]    Script Date: 01/21/2011 15:08:34 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
CREATE TABLE [dbo].[QD_HoldDetail](
[SITE] [char](4) NOT NULL,
[HOLDTICKET] [int] NOT NULL,
[REASON] [char](15) NOT NULL,
 CONSTRAINT [PK_QD_HoldDetail] PRIMARY KEY CLUSTERED 
(
[SITE] ASC,
[HOLDTICKET] ASC,
[REASON] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
SET ANSI_PADDING OFF
GO
/****** Object:  Table [dbo].[QD_Hold]    Script Date: 01/21/2011 15:08:34 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
CREATE TABLE [dbo].[QD_Hold](
[SITE] [char](4) NOT NULL,
[PALLETNUM] [char](20) NULL,
[HOLDTICKET] [int] NOT NULL,
[STATUS] [char](1) NULL,
[DISPOSITION] [char](500) NULL,
[COMMENTS] [char](1000) NULL,
[date] [int] NULL,
[time] [int] NULL,
[UserID] [char](20) NULL,
[PONumber] [char](20) NULL,
[DispositionDate] [int] NULL,
[OraclePallet] [tinyint] NULL,
[ProductCode] [varchar](30) NULL,
[WeightLbs] [decimal](15, 4) NULL,
[LineNumber] [varchar](10) NULL,
[Cases] [decimal](10, 2) NULL,
[LotCode] [decimal](3, 0) NULL,
[SkidNumber] [decimal](14, 0) NULL,
[CustomerName] [varchar](50) NULL,
[WIP] [tinyint] NULL,
[TimeEntry] [varchar](10) NULL,
[WIPSequence] [int] NULL,
[ExpectedReworkCost] [decimal](10, 2) NULL,
[HoldDateTime] [datetime] NULL,
[DispositionDateTime] [datetime] NULL,
 CONSTRAINT [PK_QD_Hold] PRIMARY KEY CLUSTERED 
(
[SITE] ASC,
[HOLDTICKET] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
SET ANSI_PADDING OFF
GO
/****** Object:  Table [dbo].[QD_changes]    Script Date: 01/21/2011 15:08:34 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
CREATE TABLE [dbo].[QD_changes](
[SITE] [char](4) NOT NULL,
[PALLETNUM] [char](20) NOT NULL,
[ChangeSequence] [int] NOT NULL,
[HOLDTICKET] [int] NULL,
[STATUSOLD] [char](1) NULL,
[STAUSNEW] [char](1) NULL,
[USERID] [char](20) NULL,
[ChangeDate] [int] NULL,
[ChangeTime] [int] NULL,
 CONSTRAINT [PK_QD_changes] PRIMARY KEY CLUSTERED 
(
[SITE] ASC,
[PALLETNUM] ASC,
[ChangeSequence] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
SET ANSI_PADDING OFF
GO
/****** Object:  Table [dbo].[A_SavedQueries]    Script Date: 01/21/2011 15:08:34 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
CREATE TABLE [dbo].[A_SavedQueries](
[Site] [char](4) NOT NULL,
[LoginID] [char](12) NOT NULL,
[QuerySequence] [int] NOT NULL,
[ScreenName] [varchar](100) NULL,
[DateCreated] [datetime] NULL,
[QueryName] [varchar](50) NULL,
[QueryText] [varchar](5000) NULL,
[rowguid] [varchar](36) NULL,
 CONSTRAINT [PK_A_SavedQueries] PRIMARY KEY CLUSTERED 
(
[Site] ASC,
[LoginID] ASC,
[QuerySequence] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
SET ANSI_PADDING OFF
GO
/****** Object:  Table [dbo].[A_Reports]    Script Date: 01/21/2011 15:08:34 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
CREATE TABLE [dbo].[A_Reports](
[DESCRIPTION] [char](100) NULL,
[MODULE] [char](20) NULL,
[CATEGORY] [char](10) NULL,
[NOTES] [char](200) NULL,
[CPROCEDURE] [char](30) NOT NULL,
[TAUTHOR] [char](20) NULL,
[LocationFlags] [char](100) NULL,
[rowguid] [varchar](36) NULL,
 CONSTRAINT [PK_A_Reports] PRIMARY KEY CLUSTERED 
(
[CPROCEDURE] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY],
 CONSTRAINT [A_RepA_K_RR] UNIQUE NONCLUSTERED 
(
[CATEGORY] ASC,
[DESCRIPTION] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY],
 CONSTRAINT [index_1282103608] UNIQUE NONCLUSTERED 
(
[rowguid] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
SET ANSI_PADDING OFF
GO
/****** Object:  Table [dbo].[A_GenericValues]    Script Date: 01/21/2011 15:08:34 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[A_GenericValues](
[String1] [nchar](20) NOT NULL
) ON [PRIMARY]
GO
/****** Object:  Table [dbo].[Que_File]    Script Date: 01/21/2011 15:08:34 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
CREATE TABLE [dbo].[Que_File](
[QueID] [int] NOT NULL,
[Procname] [char](20) NOT NULL,
[Name] [char](20) NULL,
[Query] [char](1500) NOT NULL,
 CONSTRAINT [KQueID] PRIMARY KEY CLUSTERED 
(
[QueID] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY],
 CONSTRAINT [KProcname] UNIQUE NONCLUSTERED 
(
[Procname] ASC,
[Name] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
SET ANSI_PADDING OFF
GO
/****** Object:  Table [dbo].[QL_Defects]    Script Date: 01/21/2011 15:08:34 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
CREATE TABLE [dbo].[QL_Defects](
[Site] [varchar](4) NOT NULL,
[CatShort] [char](10) NOT NULL,
[Category] [char](30) NULL,
 CONSTRAINT [PK_QL_Defects] PRIMARY KEY CLUSTERED 
(
[Site] ASC,
[CatShort] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
SET ANSI_PADDING OFF
GO
/****** Object:  Table [dbo].[QD_Temp]    Script Date: 01/21/2011 15:08:34 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
CREATE TABLE [dbo].[QD_Temp](
[Site] [char](4) NOT NULL,
[PalletNum] [char](20) NOT NULL,
[TempSequence] [int] NOT NULL,
[Temperature] [decimal](7, 2) NULL,
 CONSTRAINT [PK_ID_Temp] PRIMARY KEY CLUSTERED 
(
[Site] ASC,
[PalletNum] ASC,
[TempSequence] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
SET ANSI_PADDING OFF
GO
/****** Object:  Table [dbo].[QD_Offlinedetail]    Script Date: 01/21/2011 15:08:34 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
CREATE TABLE [dbo].[QD_Offlinedetail](
[InspOrder] [char](20) NOT NULL,
[CatShort] [char](10) NOT NULL,
[subshort] [char](10) NOT NULL,
[DefCount] [int] NULL,
[Site] [char](4) NOT NULL,
 CONSTRAINT [PK_QD_Offlinedetail] PRIMARY KEY CLUSTERED 
(
[Site] ASC,
[InspOrder] ASC,
[CatShort] ASC,
[subshort] ASC
)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
SET ANSI_PADDING OFF
GO
/****** Object:  Check [CK__QD_Hold__STATUS__07020F21]    Script Date: 01/21/2011 15:08:34 ******/
ALTER TABLE [dbo].[QD_Hold]  WITH CHECK ADD CHECK  (([STATUS]='C' OR [STATUS]='P' OR [STATUS]='H'))
GO
/****** Object:  ForeignKey [QDOD_K_SiteInsp]    Script Date: 01/21/2011 15:08:34 ******/
ALTER TABLE [dbo].[QD_Offlinedetail]  WITH CHECK ADD  CONSTRAINT [QDOD_K_SiteInsp] FOREIGN KEY([Site], [InspOrder])
REFERENCES [dbo].[QD_Offline] ([Site], [InspOrder])
GO
ALTER TABLE [dbo].[QD_Offlinedetail] CHECK CONSTRAINT [QDOD_K_SiteInsp]
GO